# Prelude Client

This package supplies easy python access to the [Prelude](https://prelude.org) APIs.

## Usage

To use the latest release:
```
pip install preludeorg
```
Then create an instance of a Detect class and call one of the available functions:

* install_endpoint: register the host as an endpoint on your account, then download and install a mini agent.
* add_ttp: add a new TTP to your active list, so your minis will start executing it.

Example:
```
from preludeorg import detect

account = detect.Account('accountID', 'token')
account.install_endpoint()
account.add_ttp('ttp_id', 'ttp_checksum')
```

## Developers guide

Make changes to the prelude.py client file, then repackage locally before testing normally:
```
pip install .
```

To publish a new version of this package:
```commandline
python -m build
python -m twine upload --repository pypi dist/*
```