import os
import platform
import socket
import stat
import subprocess
import requests


class Account:

    def __init__(self, account_id, token, hq='http://localhost:8080'):
        self.hq = hq
        self.account_id = account_id
        self.token = token

    def install_endpoint(self):
        try:
            print('Registering new endpoint: %s' % socket.gethostname())
            headers = dict(accountID=self.account_id, token=self.token)
            payload = dict(identifiers=[socket.gethostname()])
            res = requests.post('%s/account/endpoint' % self.hq, headers=headers, json=payload)
            host = next(i for i in res.json() if i['endpoint_id'] == socket.gethostname())

            print('Downloading new mini binary...')
            headers = dict(token=host['token'])
            res = requests.get('%s/0.8.0/download/%s' % (self.hq, platform.platform()), headers=headers, allow_redirects=True)
            open('detect', 'wb').write(res.content)

            print('Marking ./detect file as executable')
            st = os.stat('detect')
            os.chmod('detect', st.st_mode | stat.S_IEXEC)

            print('Mini ready. Starting!')
            os.environ['PRELUDE_TOKEN'] = host['token']
            subprocess.run(['./detect'])
        except Exception as ex:
            print('Failed to register this host as an endpoint. Reason: %s' % ex)

    def add_ttp(self, ttp, checksum):
        try:
            payload = dict(checksums={ttp: checksum})
            res = requests.put('%s/account' % self.hq, headers=dict(token=self.token), json=payload)
            if res.status_code == 200:
                print('Added active TTP: %s' % ttp)
            else:
                print('Failed to add, reason: %s' % res.status_code)
        except Exception as ex:
            print('Failed to add TTP. Reason: %s' % ex)
